'setting up the constants _clkmode _xinfreq is a must
'in RC-slow or RC-fast-mode the timing-deviation
'of the bitbanging is too high
CON      
  _clkmode = xtal1 + pll16x  
  _xinfreq = 5_000_000

  'defining constants have two advantages
  '1) you get selfexplaining code
  '2) if you want to change a value there is ONE central place to do this and you are done 
  PropRx_Pin = 10 'adjust the IO-Pin-number of Rx and Tx to your needs
  PropTx_Pin = 11
  Mode       = 0
  Baudrate   = 9600 'have to adjust this baudrate to the one your device has
         
OBJ       'the object FullDuplexSerialPlus has more useful
          'methods than FullDuplexSerial
  Debug : "FullDuplexSerialPlus" 'serial connection to PC for debugging purposes       
  Serial: "FullDuplexSerialPlus" 'serial connection to device
  
PUB Main | Char

  Debug.Start(31,30,0,115200) 'start(rxpin, txpin, mode, baudrate) :
  '"rx" and "tx" viewed from Propeller-Chip Propeller-Chip-PIN-Tx ----> PC

  Serial.Start(PropRx_Pin, PropTx_Pin, Mode, Baudrate)
  '"rx" and "tx" viewed from Propeller-Chip Propeller-Chip-PIN-Tx ----> your device
            'direct hardcoded string using the command string()
  Debug.Str(string("Debug.Start and Serial.Start done",13))
  Debug.Tx(13)

  repeat
    'DAT-section strings are called with the "@"-operator
    Serial.Str(@RequestString) 
    
    Debug.Str(@RequestString)
    Debug.Str(@MsgStr1)
    Char := Debug.rxtime(3000) 'returns -1 when no byte is received

    if Char == -1
      Debug.Str(@MsgStr2)
    else
      Debug.Str(string("received byte:"))
      Debug.Tx(Char)
      Debug.Tx(13)

    Debug.Tx(13)
    Debug.Tx(13)

DAT
  'bytesequences defined in the DAT-section
  'set characters into double-hyphens
  'add ,13 for carriage return add ,0
  'as the zerotermination of the string
  'variabletype HAS TO BE byte
  RequestString byte "ZA1",0
  MsgStr1       byte " sended to device Wait for 3 seconds to receive a byte...",13,0
  MsgStr2       byte "nothing received until Timeout",13,0
    